{ =========================================================================== }
{                                 JANELAS.INC                                 }
{ =========================================================================== }

{ ---> arquivo de inclusao da unidade JANELAS                                 }

{ --------------------------------------------------------------------------- }

procedure MostraNulDelCol(mat: matriz; var sair: boolean; var ja: MatLogica;
                      var nulid: byte; var determinante: real; imp: InfoPress);

var
  tam1, tam2, tam3, tam4: byte;
  HouveErro, voltar: boolean;
  ch: char;
  TelaAux: TelaPtr;

begin
  New(TelaAux); imp.racional := 0;
  JanMenuResult(''); voltar := false;
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[0, 1]);
  if (not ja.calc[0]) then
  begin
    Window(11, 22, 69, 22); Cor(7, 0);
    Write(' Calculando o determinante...                             ');
    determinante := Det(mat);
    GoToXY(1, 1);
    Write(' Calculando a nulidade...                                 ');
    nulid := Nul(mat);
    GoToXY(1, 1); Write(mens2[0, 1]);
    ja.calc[0] := true;
  end;
  Window(12, 13, 68, 19); Cor(7, 0);
  FormataElemento(nulid, tam1, tam2);
  FormataElemento(determinante, tam3, tam4);
  repeat
    if (imp.racional = 1) then
    begin
      ClrScr;
      ReformataElemento(nulid, tam1, tam2);
      ReformataElemento(determinante, tam3, tam4);
    end;
    GoToXY(17, 2); Write('Nulidade de M = ');
    if (imp.racional = 1) then
      Write(Rac(nulid, tam1, tam2))
    else
      Write(nulid:tam1);
    GoToXY(17, 5); Write('Determinante de M = ');
    if (imp.racional = 1) then
      Write(Rac(determinante, tam3, tam4))
    else
      Write(determinante:tam3:tam4);
    SalvaTela(TelaAux);
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    HouveErro := false;
    case ch of
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : imp.racional := 1;
      F5 : Termina(27, 14, 2, TelaAux, ind);
      F6 : begin
             Window(11, 22, 69, 22);
             Cor(7, 0); ClrScr;
             if (mat.m <= 17) then
               Write(MatMenu[12])
             else
               Write(MatMenu[13]);
             MostraMatriz(mat, imp);
             imp.racional := 0;
           end;
      F7 : voltar := true;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[0]) then
               begin
                 Mens(' NULIDADE/DETERMINANTE ', imp);
                 Writeln(Lst);
                 Write(Lst, ' ':((imp.largura - 30) div 2),'Nulidade de M = ');
                 if (imp.racional = 1) then
                   Writeln(Lst, Rac(nulid, tam1, tam2))
                 else
                   Writeln(Lst, nulid:tam1);
                 Write(Lst, ' ':((imp.largura - 30) div 2),
                                                      'Determinante de M = ');
                 if (imp.racional = 1) then
                   Writeln(Lst, Rac(determinante, tam3, tam4))
                 else
                   Writeln(Lst, determinante:tam3:tam4);
                 Writeln(Lst);
                 ja.imprimiu[0] := true;
               end;
               imp.tela := 1; imp.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(12, 13, 68, 19); Cor(7, 0);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatInvCol(var mat: matriz; imp: InfoPress; var sair: boolean;
                      var ja: MatLogica; var MatInv: matriz; var inv: boolean);

var
  HouveErro, voltar: boolean;
  nome, mensagem: string[30];
  ch: char;
  xpos, ypos, i: byte;
  TelaAux: TelaPtr;

begin
   New(TelaAux); imp.racional := 0;
   LimpaJanMenu;
   Window(1, 1, 80, 25);
   mensagem := ' MATRIZ INVERSA DE M ';
   GoToXY(10 + Trunc((61 - Length(mensagem))/2), 2);
   Write(mensagem);
   Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[1, 1]);
   if (not ja.calc[1]) then
   begin
     Window(11, 22, 69, 22); Cor(7, 0);
     Write(' Calculando a matriz inversa...                           ');
     MatInv := mat;
     InverteMatriz(MatInv, inv);
     GoToXY(1, 1); Write(mens2[1, 1]);
     ja.calc[1] := true;
   end;
   Window(12, 13, 68, 19); Cor(2, 0);
   if (not inv) then
   begin
     GoToXY(1, 3);
     Write('                  A MATRIZ NAO TEM INVERSA ');
     ch := ReadKey;  Exit;
   end
   else
   begin
      GoToXY(1, 3);
      Writeln('      PRESSIONE [F9] PARA VER A MATRIZ INVERSA DE M');
      Write('                    COLUNA POR COLUNA');
      SalvaTela(TelaAux);
      voltar := false;
      repeat
        HouveErro := false;
        repeat
          ch := ReadKey;
        until (ch = #0);
        ch := ReadKey;
        case ch of
          F2 : begin
                 Janela(22, 21, ' Nome da matriz? ', nome);
                 for i := 1 to Length(nome) do
                 if not (nome[i] in CaracterValido) then
                   Erro(6, 1, HouveErro);
                 if (nome <> ESC) and (not HouveErro) then
                   SalvaMatriz(MatInv, 1, nome, TelaAux);
               end;
          F3 : begin
                 voltar := true;
                 sair := true;
               end;
          F4: imp.racional := 1;
          F5 : Termina(27, 14, 7, TelaAux, ind);
          F6: begin
                SalvaTela(TelaAux);
                Window(11, 22, 69, 22);
                Cor(7, 0); ClrScr;
                if (mat.m <= 17) then
                  Write(MatMenu[12])
                else
                  Write(MatMenu[13]);
                MostraMatriz(mat, imp);
                imp.racional := 0;
                RestauraTela(TelaAux);
                Window(12, 13, 68, 19);
              end;
          F7: voltar := true;
          F8: begin
                mat := MatInv;
                for i :=  0 to 11 do
                begin
                  ja.calc[i] := false;
                  ja.imprimiu[i] := false;
                end;
                voltar := true;
              end;
          F9: begin
                Window(11, 22, 69, 22);
                Cor(7, 0); ClrScr;
                if (mat.m <= 17) then
                  Write(MatMenu[12])
                else
                  Write(MatMenu[13]);
                MostraMatriz(MatInv, imp);
                imp.racional := 0;
              end;
          AltL : Writeln(Lst);
          AltP,
          AltI : begin
                   imp.tela := 0; imp.largura := LarguraImpPapel;
                   if (not ja.imprimiu[11]) then
                   begin
                     Mens(' MATRIZ M ', imp);
                     Writeln(Lst);
                     MostraMatriz(mat, imp);
                     Writeln(Lst);
                     ja.imprimiu[11] := true;
                   end;
                   if (not ja.imprimiu[1]) then
                   begin
                     Mens(' MATRIZ INVERSA DE M ', imp);
                     Writeln(Lst);
                     MostraMatriz(MatInv, imp);
                     Writeln(Lst);
                     ja.imprimiu[1] := true;
                   end;
                   imp.tela := 1; imp.largura := 56;
                 end;
          end;
          RestauraTela(TelaAux);
          Window(12, 13, 68, 19); Cor(2, 0);
        until voltar;
   end;
   Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure  MostraMatEscCol(var mat: matriz; imp: InfoPress; var sair: boolean;
                                        var ja: MatLogica; var MatEsc: matriz);

var
  HouveErro, voltar: boolean;
  nome, mensagem: string[30];
  ch: char;
  xpos, ypos, i: byte;
  TelaAux: TelaPtr;

begin
   New(TelaAux);
   LimpaJanMenu;
   Window(1, 1, 80, 25);
   mensagem := ' MATRIZ M ESCALONADA ';
   GoToXY(10 + Trunc((61 - Length(mensagem))/2), 2);
   Write(mensagem);
   Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[2, 1]);
   if (not ja.calc[2]) then
   begin
     Write(' Escalonando a matriz...                                  ');
     MatEsc := mat;
     EscalonaMatriz(MatEsc, 2);
     GoToXY(1, 1); Write(mens2[2, 1]);
     ja.calc[2] := true;
   end;
   Window(12, 13, 68, 19); Cor(2, 0);
   GoToXY(1, 3);
   Writeln('      PRESSIONE [F9] PARA VER A MATRIZ M ESCALONADA');
   Write  ('                    COLUNA POR COLUNA');
   SalvaTela(TelaAux);
   voltar := false; imp.racional := 0;
   repeat
     HouveErro := false;
     repeat
       ch := ReadKey;
     until (ch = #0);
     ch := ReadKey;
     case ch of
       F2 : begin
              Janela(22, 21, ' Nome da matriz? ', nome);
              for i := 1 to Length(nome) do
                if not (nome[i] in CaracterValido) then
                  Erro(6, 1, HouveErro);
              if (nome <> ESC) and (not HouveErro) then
                SalvaMatriz(MatEsc, 1, nome, TelaAux);
            end;
       F3 : begin
              voltar := true;
              sair := true;
            end;
       F4 : imp.racional := 1;
       F5 : Termina(27, 14, 7, TelaAux, ind);
       F6 : begin
              SalvaTela(TelaAux);
              Window(11, 22, 69, 22);
              Cor(7, 0); ClrScr;
              if (mat.m <= 17) then
                Write(MatMenu[12])
              else
                Write(MatMenu[13]);
              MostraMatriz(mat, imp);
              imp.racional := 0;
            end;
       F7 : voltar := true;
       F8 : begin
              mat := MatEsc;
              for i :=  0 to 11 do
              begin
                ja.calc[i] := false;
                ja.imprimiu[i] := false;
              end;
              voltar := true;
            end;
       F9 : begin
              Window(11, 22, 69, 22);
              Cor(7, 0); ClrScr;
              if (mat.m <= 17) then
                Write(MatMenu[12])
              else
                Write(MatMenu[13]);
              MostraMatriz(MatEsc, imp);
            end;
       AltL : Writeln(Lst);
       AltP,
       AltI : begin
                imp.tela := 0; imp.largura := LarguraImpPapel;
                if (not ja.imprimiu[11]) then
                begin
                  Mens(' MATRIZ M ', imp);
                  Writeln(Lst);
                  MostraMatriz(mat, imp);
                  Writeln(Lst);
                  ja.imprimiu[11] := true;
                end;
                if (not ja.imprimiu[2]) then
                begin
                  Mens(' MATRIZ M ESCALONADA ', imp);
                  Writeln(Lst);
                  MostraMatriz(MatEsc, imp);
                  Writeln(Lst);
                  ja.imprimiu[2] := true;
                end;
                imp.tela := 1; imp.largura := 56;
              end;
     end;
     RestauraTela(TelaAux);
     Window(12, 13, 68, 19); Cor(2, 0);
   until voltar;
   Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraAutovalCol(mat: matriz; var sair: boolean; var ja: MatLogica;
                    var PolCar: polinomio; var w: autovalores; imp: InfoPress);

var
  tam1, tam2, racional: byte;
  HouveErro, voltar: boolean;
  ch: char;
  TelaAux: TelaPtr;
  op: InfoPress;

begin
  New(TelaAux);
  JanMenuResult(' Autovalores ');
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[3, 1]);
  op.racional := 0; voltar :=  false;
  op.largura :=  56; op.MaxL :=  5;
  op.tela := 1; op.opcao := 1; op.n := mat.m;
  if (not ja.calc[4]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio caracterstico...                 ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[3, 1]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando os autovalores...                             ');
    CalculaAutovalores(PolCar, w);
    GoToXY(1, 1); Write(mens2[3, 1]);
    ja.calc[3] := true;
  end;
  Window(12, 13, 68, 19); Cor(7, 0);
  ImprimeAutovalores(w, op);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela2(22, 21, ' Salvando... ');
             SalvaAutovalores(w, mat.m, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             op.racional := 1; ClrScr;
             ImprimeAutovalores(w, op);
           end;
      F5 : Termina(27, 14, 2, TelaAux, ind);
      F6 : begin
             Window(11, 22, 69, 22);
             Cor(7, 0); ClrScr;
             if (mat.m <= 17) then
               Write(MatMenu[12])
             else
               Write(MatMenu[13]);
             MostraMatriz(mat, imp);
           end;
      F7 : voltar := true;
      F10 : begin
             ClrScr;
             ImprimeAutovalores(w, op);
           end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[3]) then
               begin
                 Mens(' AUTOVALORES ', op);
                 Writeln(Lst);
                 ImprimeAutovalores(w, op);
                 Writeln(Lst);
                 ja.imprimiu[3] := true;
               end;
               op.tela := 1; op.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(12, 13, 68, 19); Cor(7, 0);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraPolCarCol(mat: matriz; var sair: boolean; var ja: MatLogica;
                    var PolCar: polinomio; var w: autovalores; imp: InfoPress);

var
  tam1, tam2: byte;
  HouveErro, voltar: boolean;
  ch, x: char;
  TelaAux: TelaPtr;
  op: InfoPress;
  min: minimo;

begin
  New(TelaAux);
  JanMenuResult(' Polinmio caracterstico ');
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[4, 1]);
  op.racional := 0; voltar :=  false;
  op.largura :=  56; op.MaxL :=  2;
  op.tela := 1; op.opcao := 1;
  if (not ja.calc[4]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio caracterstico...                 ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[4, 1]);
    ja.calc[4]  := true;
  end;
  Window(12, 13, 68, 19); Cor(7, 0);
  ImprimePolinomioCaracteristico(PolCar, 'P', 'x', op);
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F2 : begin
             Janela2(22, 21, ' Salvando... ');
             SalvaPolCaracteristico(PolCar, TelaAux);
           end;
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             op.racional := 1; ClrScr;
             ImprimePolinomioCaracteristico(PolCar, 'P', 'x', op);
           end;
      F5 : Termina(27, 14, 2, TelaAux, ind);
      F6 : begin
             Window(11, 22, 69, 22);
             Cor(7, 0); ClrScr;
             if (mat.m <= 17) then
               Write(MatMenu[12])
             else
               Write(MatMenu[13]);
             MostraMatriz(mat, imp);
           end;
      F7 : voltar := true;
      F10 : begin
              ClrScr;
              if (not ja.calc[3]) then
              begin
                Window(11, 22, 69, 22); Cor(7, 0);
                Write(
                ' Fatorando o polinmio caracterstico...                  ');
                CalculaAutovalores(PolCar, w);
                GoToXY(1, 1);
                Write
                (' F2: Salva F3: Nova matriz F4: Rac. F7: Volta F10: Repete ');
                ja.calc[3] := true;
              end;
              Window(12, 13, 68, 19);
              ImprimePolinomioMinimo(w, 'P', 'x', min, op);
              x  := ReadKey;
              if (x =  #0) then
              begin
                x :=  ReadKey;
                if (x =  F10) then
                begin
                  Window(12, 13, 68, 19);
                  ImprimePolinomioMinimo(w, 'P', 'x', min, op);
                end;
              end
              else
                RestauraTela(TelaAux);
            end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[4]) then
               begin
                 Mens(' POLINOMIO CARACTERISTICO ', op);
                 Writeln(Lst);
                 ImprimePolinomioCaracteristico(PolCar, 'P', 'x', op);
                 Writeln(Lst);
                 ja.imprimiu[4] := true;
               end;
               op.tela := 1; op.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(12, 13, 68, 19); Cor(7, 0);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatPotCol(var mat: matriz; imp: InfoPress; var sair: boolean;
                                                            var ja: MatLogica);

var
  HouveErro, voltar: boolean;
  nome, mensagem, NStr: string[30];
  ch: char;
  xpos, ypos, i: byte;
  aux: matriz;
  TelaAux: TelaPtr;

begin
   New(TelaAux); aux := mat;
   Str(imp.n, NStr); LimpaJanMenu;
   Window(1, 1, 80, 25);
   mensagem := ' MATRIZ M ^ ' + NStr;
   GoToXY(10 + Trunc((61 - Length(mensagem))/2), 2);
   Write(mensagem);
   Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[5, 1]);
   ElevaMatriz(aux, imp.n);
   Window(12, 13, 68, 19); Cor(2, 0);
   GoToXY(1, 3);
   Writeln('         PRESSIONE [F9] PARA VER A MATRIZ M ^ ' + NStr);
     Write('                   COLUNA POR COLUNA');
   SalvaTela(TelaAux);
   voltar := false; imp.racional := 0;
   repeat
     HouveErro := false;
     repeat
       ch := ReadKey;
     until (ch = #0);
     ch := ReadKey;
     case ch of
       F2 : begin
              Janela(22, 21, ' Nome da matriz? ', nome);
              for i := 1 to Length(nome) do
                if not (nome[i] in CaracterValido) then
                  Erro(6, 1, HouveErro);
              if (nome <> ESC) and (not HouveErro) then
                SalvaMatriz(aux, 1, nome, TelaAux);
            end;
       F3 : begin
              voltar := true;
              sair := true;
            end;
       F4 : imp.racional := 1;
       F5 : Termina(27, 14, 7, TelaAux, ind);
       F6 : begin
               Window(11, 22, 69, 22);
               Cor(7, 0); ClrScr;
               if (mat.m <= 17) then
                 Write(MatMenu[12])
               else
                 Write(MatMenu[13]);
               MostraMatriz(mat, imp);
             end;
       F7 : voltar := true;
       F8 : begin
               mat := aux;
               for i :=  0 to 11 do
               begin
                 ja.calc[i] := false;
                 ja.imprimiu[i] := false;
               end;
               voltar := true;
             end;
       F9 : begin
               Window(11, 22, 69, 22);
               Cor(7, 0); ClrScr;
               if (mat.m <= 17) then
                 Write(MatMenu[12])
               else
                 Write(MatMenu[13]);
               MostraMatriz(aux, imp);
             end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[5]) then
               begin
                 Mens(' MATRIZ M ^ ' + NStr, imp);
                 Writeln(Lst);
                 MostraMatriz(aux, imp);
                 Writeln(Lst);
                 ja.imprimiu[5] := true;
               end;
               imp.tela := 1; imp.largura := 56;
             end;
       end;
       RestauraTela(TelaAux);
       Window(12, 13, 68, 19); Cor(2, 0);
     until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraMatSemCol(var mat: matriz; imp: InfoPress;
           tela2, tela3, tela4: TelaPtr; var sair: boolean; var ja: MatLogica);


var
  xpos, ypos, i, tam1, tam2: byte;
  HouveErro, inv, voltar: boolean;
  modo, ch: char;
  p, aux: matriz;
  TelaAux: TelaPtr;
  mensagem, nome: string[30];

begin
  New(TelaAux);
  aux := mat; imp.racional := 0;
  LimpaJanMenu; Window(1, 1, 80, 25);
  mensagem := ' MATRIZ SEMELHANTE A M ';
  GoToXY(10 + Trunc((61 - Length(mensagem))/2), 2);
  Write(mensagem);
  Window(11, 22, 69, 22); Cor(7, 0);
  Write(' Calculando uma matriz semelhante a M...                  ');
  Window(12, 13, 68, 19); Cor(2, 0); ClrScr;
  SalvaTela(TelaAux);
  p.m := mat.m; p.n := mat.n;
  nome := 'Olezinho';
  MostraTela(tela3);
  ModoDeEntrada(modo, nome);
  case modo of
    '1' : begin
            MostraTela(tela4);
            LeTeclado(p);
          end;
    '2' : begin
            LeMatrizDisco(p, nome, HouveErro);
            if HouveErro then
            begin
              Erro(2, 1, HouveErro);
              Exit;
            end;
            if (p.m <> mat.m) then
            begin
              Erro(7, 1, HouveErro);
              Exit;
            end;
          end;
    '3' : GeraMatrizAleatoria(p, 3);
  end;
  RestauraTela(TelaAux);
  aux := p;
  InverteMatriz(aux, inv);
  Window(12, 13, 68, 19); Cor(2, 0); ClrScr;
  if (not inv) then
  begin
    Writeln; Writeln; Writeln;
    Write('                  A MATRIZ P NAO TEM INVERSA ');
    ch := ReadKey;  Exit;
  end
  else
  begin
    MultiplicaMatrizes(aux, mat, aux);
    MultiplicaMatrizes(aux, p, aux);
  GoToXY(1, 2);
  Writeln('                                            -1');
  Writeln('          PRESSIONE [F9] PARA VER A MATRIZ P  MP');
  Write('                    COLUNA POR COLUNA');
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[6, 1]);
  SalvaTela(TelaAux);
    voltar := false;
    repeat
      HouveErro := false;
      repeat
        ch := ReadKey;
      until (ch = #0);
      ch := ReadKey;
      case ch of
        F2 : begin
               Janela(22, 21, ' Nome da matriz? ', nome);
               for i := 1 to Length(nome) do
                 if not (nome[i] in CaracterValido) then
                   Erro(6, 1, HouveErro);
               if (nome <> ESC) and (not HouveErro) then
                 SalvaMatriz(aux, 1, nome, TelaAux);
             end;
        F3 : begin
               voltar := true;
               sair := true;
             end;
        F4 : imp.racional := 1;
        F5 : Termina(27, 14, 7, TelaAux, ind);
        F6 : begin
               Window(11, 22, 69, 22);
               Cor(7, 0); ClrScr;
               if (mat.m <= 17) then
                 Write(MatMenu[12])
               else
                 Write(MatMenu[13]);
               MostraMatriz(mat, imp);
            end;
        F7: voltar := true;
        F8: begin
              mat := aux;
              for i :=  0 to 11 do
              begin
                ja.calc[i] := false;
                ja.imprimiu[i] := false;
              end;
              voltar := true;
            end;
        F9 : begin
               Window(11, 22, 69, 22);
               Cor(7, 0); ClrScr;
               if (mat.m <= 17) then
                 Write(MatMenu[12])
               else
                 Write(MatMenu[13]);
               MostraMatriz(aux, imp);
             end;
        AltL : Writeln(Lst);
        AltP,
        AltI : begin
                 imp.tela := 0; imp.largura := LarguraImpPapel;
                 if (not ja.imprimiu[11]) then
                 begin
                   Mens(' MATRIZ M ', imp);
                   Writeln(Lst);
                   MostraMatriz(mat, imp);
                   Writeln(Lst);
                   ja.imprimiu[11] := true;
                 end;
                 if (not ja.imprimiu[6]) then
                 begin
                   Mens(' MATRIZ SEMELHANTE A M ', imp);
                   Writeln(Lst);
                   MostraMatriz(aux, imp);
                   Writeln(Lst);
                   ja.imprimiu[6] := true;
                 end;
                 imp.tela := 1; imp.largura := 56;
             end;
        end;
        Window(12, 13, 68, 19); Cor(2, 0);
        RestauraTela(TelaAux);
      until voltar;
  end;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraPolMinCol(mat: matriz; var sair: boolean; var ja: MatLogica;
   var PolCar: polinomio; var w: autovalores; var min: minimo; imp: InfoPress);

var
  i, racional: byte;
  HouveErro, diagonalizavel, voltar: boolean;
  ch: char;
  TelaAux: TelaPtr;
  op: InfoPress;

begin
  New(TelaAux);
  JanMenuResult(' Polinmio mnimo ');
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[7, 1]);
  op.racional := 0; voltar :=  false;
  op.largura :=  56; op.MaxL :=  2;
  op.tela := 1; op.opcao := 2;
  if (not ja.calc[4]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio caracterstico...                 ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[7, 1]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando os autovalores...                             ');
    CalculaAutovalores(PolCar, w);
    GoToXY(1, 1); Write(mens2[7, 1]);
    ja.calc[3] := true;
  end;
  if (not ja.calc[7]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio mnimo...                         ');
    PolMinimo(mat, w, min);
    GoToXY(1, 1); Write(mens2[7, 1]);
    ja.calc[7] := true;
  end;
  Window(12, 13, 68, 19); Cor(7, 0);
  ImprimePolinomioMinimo(w, 'm', 'x', min, op);
  diagonalizavel := true;
  for i := 1 to (w.QuantRe + w.QuantComplex) do
    if (min.expo[i]  > 1) then diagonalizavel := false;
  if diagonalizavel then
  begin
    Window(11, 11, 70, 20);
    GoToXY(18, 10); Write(' A MATRIZ  DIAGONALIZAVEL ');
    Window(12, 13, 68, 19); Cor(7, 0);
  end;
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             op.racional := 1; ClrScr;
             ImprimePolinomioMinimo(w, 'm', 'x', min, op);
             SalvaTela(TelaAux);
           end;
      F5 : Termina(27, 14, 2, TelaAux, ind);
      F6 : begin
             Window(11, 22, 69, 22);
             Cor(7, 0); ClrScr;
             if (mat.m <= 17) then
               Write(MatMenu[12])
             else
               Write(MatMenu[13]);
             MostraMatriz(mat, imp);
           end;
      F7 : voltar := true;
      F10 : begin
              ClrScr;
              ImprimePolinomioMinimo(w, 'm', 'x', min, op);
            end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[7]) then
               begin
                 Mens(' POLINOMIO MINIMO ', op);
                 Writeln(Lst);
                 ImprimePolinomioMinimo(w, 'm', 'x', min, op);
                 Writeln(Lst);
                 ja.imprimiu[7] := true;
               end;
               op.tela := 1; op.largura := 56;
             end;
      end;
    RestauraTela(TelaAux);
    Window(12, 13, 68, 19); Cor(7, 0);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure MostraAutovetCol(mat: matriz; var sair: boolean; var ja: MatLogica;
                    var PolCar: polinomio; var w: autovalores; imp: InfoPress);

var
  i, tam1, tam2, racional: byte;
  HouveErro, voltar: boolean;
  ch: char;
  TelaAux: TelaPtr;
  op: InfoPress;
  auto: AutovetorReal;

begin
  New(TelaAux);
  JanMenuResult(' Autovetores reais ');
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[8, 1]);
  op.racional := 0; voltar :=  false;
  op.largura :=  56; op.MaxL :=  5;
  op.tela := 1; op.opcao := 1; op.n := mat.m;
  if (not ja.calc[4]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio caracterstico...                 ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[8, 1]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando os autovalores...                             ');
    CalculaAutovalores(PolCar, w);
    GoToXY(1, 1); Write(mens2[8, 1]);
    ja.calc[3] := true;
  end;
  Window(12, 13, 68, 19); Cor(7, 0);
  if (w.QuantRe = 0) then
  begin
    GoToXY(15, 4);
    Write('NAO EXISTEM AUTOVALORES REAIS');
    ch := ReadKey;
    Exit;
  end
  else
    for i := 1 to w.QuantRe do
    begin
      op.ultimo := (i = w.QuantRe);
      CalculaAutovetores(mat, w.AutovalorRe[i].x, auto);
      ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
    end;
  SalvaTela(TelaAux);
  repeat
    HouveErro := false;
    repeat
      ch := ReadKey;
    until (ch = #0);
    ch := ReadKey;
    case ch of
      F3 : begin
             voltar := true;
             sair := true;
           end;
      F4 : begin
             op.racional := 1; ClrScr;
             for i := 1 to w.QuantRe do
               ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
           end;
      F5 : Termina(27, 14, 2, TelaAux, ind);
      F6 : begin
             Window(11, 22, 69, 22);
             Cor(7, 0); ClrScr;
             if (mat.m <= 17) then
               Write(MatMenu[12])
             else
               Write(MatMenu[13]);
             MostraMatriz(mat, imp);
           end;
      F7 : voltar := true;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               op.tela := 0; op.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', op);
                 Writeln(Lst);
                 MostraMatriz(mat, op);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[8]) then
               begin
                 Mens(' AUTOVETORES ', op);
                 Writeln(Lst);
                 for i := 1 to w.QuantRe do
                 begin
                   op.ultimo := (i = w.QuantRe);
                   CalculaAutovetores(mat, w.AutovalorRe[i].x, auto);
                   ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
                 end;
                 Writeln(Lst);
                 ja.imprimiu[8] := true;
               end;
               op.tela := 1; op.largura := 56;
             end;
    end;
    RestauraTela(TelaAux);
    Window(12, 13, 68, 19); Cor(7, 0);
  until voltar;
  Dispose(TelaAux);
end;

{ --------------------------------------------------------------------------- }

procedure  MostraMatJorCol(var mat: matriz; imp: InfoPress; var sair: boolean;
  var ja:  MatLogica;   var MatJor: matriz;  var BaseJor: matriz;  var PolCar:
  polinomio; var w: autovalores; var min: minimo; var db: DBlocos);

var
  AchouBase, HouveErro, voltar: boolean;
  nome, mensagem, NStr: string[30];
  x, ch: char;
  tam1, tam2, xpos, ypos, i: byte;
  TelaAux: TelaPtr;
  op: InfoPress;

begin
  New(TelaAux); op.opcao := 1;
  LimpaJanMenu;
  Window(1, 1, 80, 25);
  mensagem := ' FORMA DE JORDAN DE M ';
  GoToXY(10 + Trunc((61 - Length(mensagem))/2), 2);
  Write(mensagem);
  op.racional := 0; voltar :=  false;
  op.largura :=  56; op.MaxL :=  5;
  op.tela := 1; op.opcao := 1; op.n := mat.m;
  Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[9, 1]);
  if (not ja.calc[4]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio caracterstico...                 ');
    PolCaracteristico(mat, PolCar);
    GoToXY(1, 1); Write(mens2[9, 1]);
    ja.calc[4] := true;
  end;
  if (not ja.calc[3]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando os autovalores...                             ');
    CalculaAutovalores(PolCar, w);
    GoToXY(1, 1); Write(mens2[9, 1]);
    ja.calc[3] := true;
  end;
  if (not ja.calc[7]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando o polinmio mnimo...                         ');
    PolMinimo(mat, w, min);
    GoToXY(1, 1); Write(mens2[9, 1]);
    ja.calc[7] := true;
  end;
  if (not ja.calc[9]) then
  begin
    GoToXY(1, 1);
    Write(' Calculando a forma de Jordan...                          ');
    CalculaFormaDeJordan(mat, w, min, HouveErro, db);
    if HouveErro then
    begin
      Erro(8, 1, HouveErro); Exit;
    end;
    FormataMatrizJordan(db, MatJor, mat.m, w, min);
    GoToXY(1, 1); Write(mens2[9, 1]);
    ja.calc[9] := true;
  end;
  Window(12, 13, 68, 19); Cor(2, 0); GoToXY(1, 3);
  Writeln('      PRESSIONE [F9] PARA VER A FORMA DE JORDAN DE M');
  Write  ('                    COLUNA POR COLUNA');
  SalvaTela(TelaAux);
   repeat
     HouveErro := false;
     repeat
       ch := ReadKey;
     until (ch = #0);
     ch := ReadKey;
     case ch of
       F2 : begin
              Janela(22, 21, ' Nome da matriz? ', nome);
              for i := 1 to Length(nome) do
                if not (nome[i] in CaracterValido) then
                  Erro(6, 1, HouveErro);
              if (nome <> ESC) and (not HouveErro) then
                SalvaMatriz(MatJor, 1, nome, TelaAux);
            end;
       F3 : begin
              voltar := true;
              sair := true;
            end;
       F4 : imp.racional := 1;
       F5 : Termina(27, 14, 7, TelaAux, ind);
       F6 : begin
              SalvaTela(TelaAux);
              Window(11, 22, 69, 22);
              Cor(7, 0); ClrScr;
              if (mat.m <= 17) then
                Write(MatMenu[12])
              else
                Write(MatMenu[13]);
              MostraMatriz(mat, imp);
            end;
       F7 : voltar := true;
       F10 : begin
               if (w.QuantComplex > 0) then
               begin
                 Erro(9, 1, HouveErro); Exit;
               end;
               if (not ja.calc[10]) then
               begin
                 Window(11, 22, 69, 22); Cor(7, 0);
                 Write
                 (' Calculando a base da forma de Jordan...                  ');
                 CalculaBaseFJordan(mat, db, min, BaseJor, AchouBase);
                 ja.calc[10] := true;
               end;
               JanMenuResult(' Base que fornece a forma de Jordan de M ');
               Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[9, 1]);
               Window(12, 13, 68, 19);
               ImprimeBase(BaseJor, op);
               repeat
                 x := ReadKey;
               until (x = #0);
               HouveErro := false;
               x :=  ReadKey;
               case x of
                 F2 : begin
                        Janela(22, 21, ' Nome da matriz? ', nome);
                        for i := 1 to Length(nome) do
                          if not (nome[i] in CaracterValido) then
                            Erro(6, 1, HouveErro);
                        if (nome <> ESC) and (not HouveErro) then
                          SalvaMatriz(BaseJor, 1, nome, TelaAux);
                      end;
                  F3: begin
                        voltar := true;
                        sair := true;
                      end;
                  F4: begin
                        imp.racional := 1;
                        Window(11, 22, 69, 22); Cor(7, 0); Write(mens2[9, 1]);
                        Window(12, 13, 68, 19);
                        ClrScr;
                        Writeln;
                        ImprimeBase(BaseJor, imp);
                        imp.racional := 0;
                        SalvaTela(TelaAux);
                      end;
                  F5 : Termina(27, 16, 7, TelaAux, ind);
                  F7 : voltar := true;
                  F8 : begin
                         mat := BaseJor;
                         for i :=  0 to 11 do
                         begin
                           ja.calc[i] := false;
                           ja.imprimiu[i] := false;
                         end;
                         voltar := true;
                        end;
                  AltL : Writeln(Lst);
                  AltP,
                  AltI : begin
                           imp.tela := 0; imp.largura := LarguraImpPapel;
                           if (not ja.imprimiu[11]) then
                           begin
                             Mens(' MATRIZ M ', imp);
                             Writeln(Lst);
                             MostraMatriz(mat, imp);
                             Writeln(Lst);
                             ja.imprimiu[11] := true;
                           end;
                           if (not ja.imprimiu[10]) then
                           begin
                             Mens(' BASE DA FORMA DE JORDAN DE M ', imp);
                             Writeln(Lst);
                             MostraMatriz(BaseJor, imp);
                             Writeln(Lst);
                             ja.imprimiu[10] := true;
                           end;
                           imp.tela := 1; imp.largura := 56;
                         end;
                    end;
              end;
       F8: begin
             mat := MatJor;
             for i :=  0 to 11 do
             begin
               ja.calc[i] := false;
               ja.imprimiu[i] := false;
             end;
             voltar := true;
           end;
       F9: begin
             Window(11, 22, 69, 22);
             Cor(7, 0); ClrScr;
             if (mat.m <= 17) then
               Write(MatMenu[12])
             else
               Write(MatMenu[13]);
             MostraMatriz(MatJor, imp);
           end;
      AltL : Writeln(Lst);
      AltP,
      AltI : begin
               imp.tela := 0; imp.largura := LarguraImpPapel;
               if (not ja.imprimiu[11]) then
               begin
                 Mens(' MATRIZ M ', imp);
                 Writeln(Lst);
                 MostraMatriz(mat, imp);
                 Writeln(Lst);
                 ja.imprimiu[11] := true;
               end;
               if (not ja.imprimiu[9]) then
               begin
                 Mens(' FORMA DE JORDAN DE M ', imp);
                 Writeln(Lst);
                 MostraMatriz(MatJor, imp);
                 Writeln(Lst);
                 ja.imprimiu[9] := true;
               end;
               imp.tela := 1; imp.largura := 80;
             end;
       end;
       RestauraTela(TelaAux);
       Window(12, 13, 68, 19); Cor(2, 0);
     until voltar;
  Dispose(TelaAux);
end;

{ =========================================================================== }

